#include <stdio.h>
#include <string.h>

#define		MAX_PREGUNTAS		1024				// Maximo numero de preguntas que puede contener la libreria
#define		MAX_NOMBRE		11				// Define la longitud maxima para el nombre de jugador
#define		MAX_FILENAME		256


// DEFINICION DE TIPOS

typedef struct {							// Cabecera del archivo savegame
	int		perfiles_totales;
	float		version;
}TCabecera_savegame;

typedef struct {							// Contiene todos los datos asociados a un jugador
	char		nombre[MAX_NOMBRE], libreria[MAX_FILENAME];
	int		puntuacion, aciertos, fallos, victorias, color;
	int		respondidas[MAX_PREGUNTAS];			// Debe ser mayor o igual al maximo numero de preguntas que tenga la libreria
}TJugador;								// es booleano, las preguntas que ya se hayan respondido corresponden a 1 y el resto a 0

typedef struct {							// Contiene todos los datos de una partida, incluidos los jugadores y las opciones
	int 		num_jugadores, tiempo_pregunta, tiradas;
	TJugador	jugador[7];
}TPartida;

	
TJugador perfiles[6];

// FUNCIONES DEL PROGRAMA

int menu()
{
	int opcion;

	system("clear");

	printf("SAVEGAME EDITOR - Freevial for PSP - 4ltrv1sm0 2010\n---------------------------------------------------\n\nMenu Options:\n\n");
	printf(" 1 - Create new empty savegame file\n 2 - Open existing savegame file and list profiles\n 3 - Append new profile to existing savegame file\n 4 - Exit");
	printf("\n\nEnter option: ");

	scanf("%d", &opcion);

	return opcion;
}

void crear_nueva(void)
{
	char 	filename[128], letra;
	int	seguir=1, i=0;
	FILE 	*file;
	TCabecera_savegame	cabecera;

	// pone los datos en cabecera que luego se escribira (a cero)
	cabecera.perfiles_totales = 0;
	cabecera.version = 0;

	system("clear");
	
	printf("CREATE NEW LIBRARY\n\nInsert filename: ");
	while(getchar()!='\n');
	scanf("%s", filename);

	if( file = fopen(filename, "wb") )
	{
		while(seguir && cabecera.perfiles_totales<=6)
		{
			printf("\n\nNEW SAVED PROFILE\n-----------------\nName: ");
			while(getchar()!='\n');
			scanf("%s", perfiles[cabecera.perfiles_totales].nombre);

			printf("Points: ");
			while(getchar()!='\n');
			scanf("%d", &perfiles[cabecera.perfiles_totales].puntuacion);
		
			printf("Rights: ");
			while(getchar()!='\n');
			scanf("%d", &perfiles[cabecera.perfiles_totales].aciertos);
		
			printf("Wrongs: ");
			while(getchar()!='\n');
			scanf("%d", &perfiles[cabecera.perfiles_totales].fallos);
		
			printf("Color (hexa) :");
			while(getchar()!='\n');
			scanf("%x", &perfiles[cabecera.perfiles_totales].color);

			printf("Won: ");
			while(getchar()!='\n');
			scanf("%d", &perfiles[cabecera.perfiles_totales].victorias);
		

			cabecera.perfiles_totales++;

			printf("Do you want to continue inserting profiles? (y/n): ");
			while(getchar()!='\n');
			scanf("%c", &letra);
			if (letra != 'y' && letra != 'Y')
				seguir = 0;
		}

		
		fwrite(&cabecera, sizeof(TCabecera_savegame), 1, file);			// Escribe la cabecera del archivo

		for (i=0; i<cabecera.perfiles_totales;i++)				// Escribe los bloques que haya
		{
			printf("\nEscrito un bloque ...");
			fwrite(&perfiles[i], sizeof(TJugador), 1, file);
		}

		fclose(file);								// Cierra el archivo

		if (!ferror(file))							// Muestra error si ha habido algun problema
			printf("\nFile created successfully\n\n");
	}
	else
	{
		printf("\nERROR: file could not be created!\n\n");
	}
}

void ver_existente(void)
{
	char 	filename[128];
	int  	i;
	FILE 	*file;
	TCabecera_savegame cabecera;

	system("clear");
	
	printf("OPEN EXISTING LIBRARY\n\nInsert filename: ");
	while(getchar()!='\n');
	scanf("%s", filename);

	if( file = fopen(filename, "rb") )
	{
		fread(&cabecera, sizeof(TCabecera_savegame), 1, file);
		
		for (i=0; i<cabecera.perfiles_totales; i++)
			fread(&perfiles[i], sizeof(TJugador), 1, file);
		fclose(file);


		printf("\nSAVEGAME REPORT - Saved profiles: %d\n----------------\n", cabecera.perfiles_totales);
		for(i=0; i<cabecera.perfiles_totales; i++)
			printf("\nName: %s\n----\nPoints: %d\nRights: %d\nWrongs: %d\nWon: %d\nColor: %x (h)\n---------------", perfiles[i].nombre, perfiles[i].puntuacion, perfiles[i].aciertos, perfiles[i].fallos,perfiles[i].victorias, perfiles[i].color);

		printf("\n\nPress enter to continue ...");
		while(getchar()!='\n');
		getchar();



	}
	else
	{
		printf("\nERROR: file could not be read!\n\n");
	}



}

void append(void)
{
	int 		resultado = -1, i=0;
	FILE		*archivo;
	TCabecera_savegame cabecera;
	char		filename[256], seguir='y';
	TJugador	perfiles[6];

	system("clear");

	printf("APPEND NEW PROFILE TO SAVEGAME FILE\n\nInsert filename: ");
	while(getchar()!='\n');
	scanf("%s", filename);

	if ( (archivo = fopen(filename, "rb")) )			// Abre el archivo de savegame para leer la cabecera
	{
		fread (&cabecera, sizeof(TCabecera_savegame), 1, archivo );

		if ( !ferror(archivo) )					// Ha podido leer la cabecera correctamente y hay menos de seis perfiles
		{
			printf("\nExisting profiles: %d\n", cabecera.perfiles_totales);

			for (i=0; i<cabecera.perfiles_totales; i++)			// Lee todos los perfiles guardados
				fread (&perfiles[i], sizeof(TJugador), 1, archivo );

			fclose(archivo);						// Cerramos el archivo pues ya hemos terminado de leerlo

			while ( ((seguir == 'y') || (seguir == 'Y')) && (cabecera.perfiles_totales < 6) )
			{
				printf("\nADD NEW\n-------\nName: ");
				while(getchar()!='\n');
				scanf("%s", perfiles[i].nombre);

				printf("Points: ");
				while(getchar()!='\n');
				scanf("%d", &perfiles[i].puntuacion);
	
				printf("Rights: ");
				while(getchar()!='\n');
				scanf("%d", &perfiles[i].aciertos);
	
				printf("Wrongs: ");
				while(getchar()!='\n');
				scanf("%d", &perfiles[i].fallos);
	
				printf("Color (hexa) :");
				while(getchar()!='\n');
				scanf("%x", &perfiles[i].color);

				printf("Won: ");
				while(getchar()!='\n');
				scanf("%d", &perfiles[i].victorias);

				printf("\nContinue? (y/n): ");
				while(getchar()!='\n');
				scanf("%c", &seguir);

				cabecera.perfiles_totales++;		// Incrementamos el total de perfiles guardados
				i++;					// Incrementamos el indice
			}

			if (cabecera.perfiles_totales == 6)
			{
				printf("\nREACHED MAX PROFILE STORAGE! ... ");
				while(getchar()!='\n');
				getchar();
			}			

			archivo = fopen(filename, "wb");

			fwrite(&cabecera, sizeof(TCabecera_savegame), 1, archivo);

			for (i=0; i<cabecera.perfiles_totales; i++)			// Lee todos los perfiles guardados
				fwrite (&perfiles[i], sizeof(TJugador), 1, archivo );

			if (ferror(archivo))
			{
				printf("\nERROR WRITING FILE! ... ");
				while(getchar()!='\n');
				getchar();
			}

			fclose(archivo);
		}
		else							// No ha podido leer el archivo de savegame
		{
			printf("ERROR LOADING FILE! ... ");
			while(getchar()!='\n');
			getchar();
			fclose(archivo);
		}
	}


}

int guardar_perfil (TJugador perfil, char filename[])			// Guarda el perfil pasado en el archivo de savegame pasado.
{									// SUPONE QUE HAY ESPACIO LIBRE (MENOS DE SEIS PERFILES ALMACENADOS YA)
	int 	i=0;							// Devuelve el numero de perfiles almacenados al final
	FILE	*archivo;
	TCabecera_savegame cabecera;
	TJugador	perfiles[6];

	if ( (archivo = fopen(filename, "rb")) )			// Abre el archivo de savegame para leer la cabecera
	{
		fread (&cabecera, sizeof(TCabecera_savegame), 1, archivo );

		if ( !ferror(archivo) )					// Ha podido leer la cabecera correctamente y hay menos de seis perfiles
		{
			for (i=0; i<cabecera.perfiles_totales; i++)			// Lee todos los perfiles guardados
				fread (&perfiles[i], sizeof(TJugador), 1, archivo );

			fclose(archivo);						// Cerramos el archivo pues ya hemos terminado de leerlo

			// Copia el perfil a guardar al final del registro
			strcpy(perfiles[i].nombre, perfil.nombre);
			perfiles[i].puntuacion = perfil.puntuacion;
			perfiles[i].aciertos = perfil.aciertos;
			perfiles[i].fallos = perfil.fallos;
			perfiles[i].color = perfil.color;
			perfiles[i].victorias = perfil.victorias;

			// Incrementamos el total de perfiles guardados
			cabecera.perfiles_totales++;

			// Escribimos el archivo completo de nuevo
			archivo = fopen(filename, "wb");				// Abrimos para escribir

			fwrite(&cabecera, sizeof(TCabecera_savegame), 1, archivo);	// Escribimos la cabecera actualizada

			for (i=0; i<cabecera.perfiles_totales; i++)			// Escribimos los perfiles
				fwrite (&perfiles[i], sizeof(TJugador), 1, archivo );

			fclose(archivo);						// Cerramos el archivo
		}
	}

	return cabecera.perfiles_totales;
}

int borrar_perfil(char filename[], int num_perfil)			// Borra el perfil cuyo indice es num_perfil dentro del archivo 'filename'
{
	FILE 		*archivo;
	int		resultado = 0, i, entrar = 1;
	TCabecera_savegame cabecera;
	TJugador	perfiles[6];

	if ( (archivo = fopen(filename, "rb")) )			// Abre el archivo de savegame para leer la cabecera
	{
		fread (&cabecera, sizeof(TCabecera_savegame), 1, archivo );

		if ( !ferror(archivo) )					// Ha podido leer la cabecera correctamente y hay menos de seis perfiles
		{
			for (i=0; i<cabecera.perfiles_totales; i++)			// Lee todos los perfiles guardados
			{
				fread (&perfiles[i], sizeof(TJugador), 1, archivo );	
				if ( (i == (num_perfil-1))  && entrar )			// Si es el que se quiere borrar se retrasa el indice
				{
					i --;						// para compensar el incremento del for y asi pisar el
					entrar =0;					// registro que se desea borrar
					cabecera.perfiles_totales--;			// Decrementa el numero total de perfiles en caso de
				}							// que la ficha a borrar exista
			}
			fclose(archivo);						// Cerramos el archivo pues ya hemos terminado de leerlo

			// Escribimos el archivo completo con la informacion modificada
			archivo = fopen(filename, "wb");				// Abrimos para escribir

			fwrite(&cabecera, sizeof(TCabecera_savegame), 1, archivo);	// Escribimos la cabecera actualizada

			for (i=0; i<cabecera.perfiles_totales; i++)			// Escribimos los perfiles
				fwrite (&perfiles[i], sizeof(TJugador), 1, archivo );

			fclose(archivo);						// Cerramos el archivo
		}
	}
	return cabecera.perfiles_totales;
}

int main(void)
{
	int opcion;

	while (opcion = menu())
	{
		if (opcion == 1)
			crear_nueva();

		if (opcion == 2)
			ver_existente();

		if (opcion == 3)
			append();

		if (opcion == 4)
			break;

	}

	printf("\nGoodbye!\n\n");
	return 0;
}
